/*
 *  $Id: mpi_ad.h,v 1.11 1994/04/15 18:44:40 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

/* user include file with dependencies on mpir.h */

#ifndef _MPI_INCLUDE_AD
#define _MPI_INCLUDE_AD

typedef MPIR_GROUP              *MPI_Group;
typedef MPIR_COMMUNICATOR       *MPI_Comm;
typedef MPIR_DATATYPE           *MPI_Datatype;
typedef MPIR_HANDLE             *MPI_Request;

/* User combination function */
#ifdef __STDC__
typedef void (MPI_Uop)( void *invec, void *inoutvec, int *len,  
			MPI_Datatype *datatype); 
#else
typedef void (MPI_Uop)();
#endif

/* MPI combination function */
typedef struct {
    MPI_Uop *op;
    int     commute;
    } MPIR_Op;
typedef MPIR_Op *MPI_Op;

/* MPI Attribute copy and delete functions */
#ifdef __STDC__
typedef int (MPI_Copy_function)( MPI_Comm *oldcomm, MPI_Comm *newcomm, 
			    int *keyval, void *extra_state );
typedef int (MPI_Delete_function)( MPI_Comm *comm, int *keyval, 
			       void *extra_state );
#else
typedef int (MPI_Copy_function)( );
typedef int (MPI_Delete_function)( );

#endif
/* elementary datatypes */
#define MPI_CHAR	   MPIR_char_dte
#define MPI_SHORT	   MPIR_short_dte
#define MPI_INT		   MPIR_int_dte
#define MPI_LONG	   MPIR_long_dte
#define MPI_FLOAT	   MPIR_float_dte
#define MPI_DOUBLE	   MPIR_double_dte
#define MPI_BYTE	   MPIR_byte_dte
#define MPI_UNSIGNED_CHAR  MPIR_uchar_dte
#define MPI_UNSIGNED_SHORT MPIR_ushort_dte
#define MPI_UNSIGNED_LONG  MPIR_ulong_dte
#define MPI_UNSIGNED_INT   MPIR_uint_dte
#define MPI_PACKED         MPIR_packed_dte
#define MPI_UB             MPIR_ub_dte
#define MPI_LB             MPIR_lb_dte
#ifdef __STDC__
#define MPI_LONG_DOUBLE    MPIR_longdouble_dte
#endif
/* need the others */

#define MPI_ANY_SOURCE 	(-1)
#define MPI_ANY_TAG	(-1)

#endif





