/*
 *  $Id: sbcnst.h,v 1.5 1994/04/06 18:43:26 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

/* %W% %G% */
#ifndef _SBCNST
#define _SBCNST
#ifndef _SBCNSTDEF
extern void *SBinit(), SBfree(), SBiAllocate(), *SBalloc(), SBPrealloc();
#endif

/* Chameleon/PETSc includes memory tracing functions that can be used
   to track storage leaks.  */
#ifndef MALLOC
#if defined(DEVICE_CHAMELEON) && defined(MPIR_DEBUG_MEM)
#define MALLOC(a)    trmalloc((unsigned)(a),__LINE__,__FILE__)
#define CALLOC(a,b)  trcalloc((unsigned)(a),(unsigned)(b),__LINE__,__FILE__)
#define FREE(a)      trfree((char *)(a),__LINE__,__FILE__)
#define NEW(a)    (a *)MALLOC(sizeof(a))
/* Also replace the SB allocators so that we can get the trmalloc line/file
   tracing. */
#define SBinit(a,b,c) ((void *)(a))
#define SBalloc(a)    trmalloc((unsigned)(a),__LINE__,__FILE__)
#define SBfree(a,b)   trfree((char *)(b),__LINE__,__FILE__)
#define SBdestroy(a)
#else
#define MALLOC(a)    malloc((unsigned)(a))
#define CALLOC(a,b)  calloc((unsigned)(a),(unsigned)(b))
#define FREE(a)      free((char *)(a))
#define NEW(a)    (a *)MALLOC(sizeof(a))
#endif /*MPIR_DEBUG_MEM*/
#endif /*MALLOC*/

#endif
