/*
 *  $Id: opcreate.c,v 1.3 1994/04/04 21:37:55 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef lint
static char vcid[] = "$Id: opcreate.c,v 1.3 1994/04/04 21:37:55 doss Exp $";
#endif /* lint */

#include <mpi.h>
#include "mpisys.h"
#include "coll.h"

/*@
  MPI_Op_create - Create a user-defined combination function handle

Input Parameters:
. function - user defined function (function) 
. commute -  true if commutative;  false otherwise. 
Output Parameter:
. op - operation (handle) 
@*/
int MPI_Op_create( function, commute, op )
MPI_Uop *function;
int     commute;
MPI_Op  *op;
{
  MPIR_Op  *newop;

  newop          = NEW( MPIR_Op );
  if (!newop) 
    return MPIR_ERROR((MPI_Comm)0, MPI_ERR_EXHAUSTED, 
                      "Out of space in MPI_OP_CREATE");
  newop->commute = commute;
  newop->op      = function;
  (*op)          = newop;
  
  return (MPI_SUCCESS);
}
