/*
 *  $Id: comm_rgroup.c,v 1.1 1994/04/07 08:57:02 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Comm_remote_group - Access the remote group associated with 
                        the given inter-communicator

@*/
int MPI_Comm_remote_group ( comm, group )
MPI_Comm comm;
MPI_Group *group;
{
  if (comm == MPI_COMM_NULL) {
    (*group) = MPI_GROUP_NULL;
    return MPIR_ERROR( MPI_COMM_NULL, MPI_ERR_COMM, 
					  "Error in MPI_COMM_GROUP" );
  }
  else {
    MPIR_Group_dup( comm->group, group );
	return (MPI_SUCCESS);
  }
}
