/*
 *  $Id: comm_rsize.c,v 1.1 1994/04/07 08:57:02 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>


/*@

MPI_Comm_remote_size - Determine the size of the remote group 
                       associated with an inter-communictor

Input Parameter:
. comm - communicator (handle) 
Output Parameter:
. size - number of processes in the group of comm  (integer) 

@*/
int MPI_Comm_remote_size ( comm, size )
MPI_Comm  comm;
int      *size;
{
  if (comm == MPI_COMM_NULL) {
    (*size) = MPI_UNDEFINED;
    return MPIR_ERROR( MPI_COMM_NULL, MPI_ERR_COMM, 
					  "Error in MPI_COMM_SIZE" );
  }
  else 
    (*size) = comm->group->np;

  return (MPI_SUCCESS);
}
