/*
 *  $Id: comm_size.c,v 1.8 1994/04/07 08:55:54 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>


/*@

MPI_Comm_size - Determine the size of the group associated with a communictor

Input Parameter:
. comm - communicator (handle) 
Output Parameter:
. size - number of processes in the group of comm  (integer) 

@*/
int MPI_Comm_size ( comm, size )
MPI_Comm comm;
int *size;
{
  if (comm == MPI_COMM_NULL) {
    (*size) = MPI_UNDEFINED;
    return MPIR_ERROR( MPI_COMM_NULL, MPI_ERR_COMM, 
					  "Error in MPI_COMM_SIZE" );
  }
  else 
    (*size) = comm->local_group->np;

  return (MPI_SUCCESS);
}
