/*
 *  $Id: errget.c,v 1.1 1994/03/29 21:42:10 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#ifndef lint
static char vcid[] = "$Id: errget.c,v 1.1 1994/03/29 21:42:10 gropp Exp $";
#endif

#include "mpi.h"

/*@
  MPI_Errhandler_get - Gets the error handler for a communicator

Input Parameter:
. comm - communicator to get the error handler from (handle) 
Output Parameter:
. errhandler - MPI error handler currently associated with communicator
(handle) 

@*/
int MPI_Errhandler_get( comm, errhandler )
MPI_Comm comm;
MPI_Errhandler *errhandler;
{
if (comm == (MPI_Comm)0) {
    return MPIR_ERROR( comm, MPI_ERR_COMM_NULL, 
		       "Error in MPI_ERRHANDLER_GET" );
    }
else
    *errhandler = comm->error_handler;
return MPI_SUCCESS;
}
