/*
 *  $Id: commreq_free.c,v 1.6 1994/03/29 22:09:13 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include "mpi.h"
#include "mpisys.h"

/*@
    MPI_Request_free - Free a communication request object

Input Parameter:
. request - communication request (handle) 
@*/
int MPI_Request_free( request )
MPI_Request *request;
{
    int errno = MPI_SUCCESS;

    if ((*request)->type == MPIR_SEND)
    {
	MPID_free_send_handle(&((*request)->shandle.dev_shandle));
	SBfree( MPIR_shandles, *request );
    }
    else if ((*request)->type == MPIR_RECV)
    {
	MPID_free_recv_handle(&((*request)->rhandle.dev_rhandle));
	SBfree( MPIR_rhandles, *request );
    }
    else
	errno = MPIR_ERROR( (MPI_Comm)0, MPI_ERR_INTERN, 
			    "MPI_Request_free:  bad request type" );
    return errno;
}

