/*
 *  $Id: irecv.c,v 1.11 1994/04/13 13:21:42 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: irecv.c,v 1.11 1994/04/13 13:21:42 gropp Exp $";
#endif /* lint */

#include "mpi.h"

/*@
    MPI_Irecv - Begin a nonblocking receive

Output Parameter:
. buf - initial address of receive buffer (choice) 
Input Parameters:
. count - number of elements in receive buffer (integer) 
. datatype - datatype of each receive buffer element (handle) 
. source - rank of source (integer) 
. tag - message tag (integer) 
. comm - communicator (handle) 
Output Parameter:
. request - communication request (handle) 
@*/
int MPI_Irecv( buf, count, datatype, source, tag, comm, request )
void             *buf;
int              count;
MPI_Datatype     datatype;
int              source;
int              tag;
MPI_Comm         comm;
MPI_Request      *request;
{
    int err;

    if (source != MPI_PROC_NULL)
    {
        if (err = 
	    MPI_Recv_init( buf, count, datatype, source, tag, comm, request ))
	    return err;
	return MPI_Start( request );
    }
    else 
	*request = 0;
    return MPI_SUCCESS;
}
