/*
 *  $Id: ssend.c,v 1.2 1994/04/13 13:23:58 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */


#ifndef lint
static char vcid[] = "$Id: ssend.c,v 1.2 1994/04/13 13:23:58 gropp Exp $";
#endif /* lint */

#include "mpi.h"

/*@
    MPI_Ssend - Basic synchronous send

Input Parameters:
. buf - initial address of send buffer (choice) 
. count - number of elements in send buffer (nonnegative integer) 
. datatype - datatype of each send buffer element (handle) 
. dest - rank of destination (integer) 
. tag - message tag (integer) 
. comm - communicator (handle) 

@*/
int MPI_Ssend( buf, count, datatype, dest, tag, comm )
void             *buf;
int              count, dest, tag;
MPI_Datatype     datatype;
MPI_Comm         comm;
{
    MPI_Request handle;
    MPI_Status  status;

    if (dest != MPI_PROC_NULL)
    {
	MPI_Issend( buf, count, datatype, dest, tag, comm, &handle );
	MPI_Wait( &handle, &status );
    }
    return MPI_SUCCESS;
}
