/*
 *  $Id: type_extent.c,v 1.1 1994/04/18 15:47:07 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include "mpi.h"
#include "mpisys.h"


/*@
    MPI_Type_extent - Return the extent of a datatype
@*/
int MPI_Type_extent( datatype, extent )
MPI_Datatype  datatype;
MPI_Aint     *extent;
{
  /* Check for bad datatype */
  if (datatype == MPI_DATATYPE_NULL) 
	return MPIR_ERROR( MPI_COMM_NULL, MPI_ERR_TYPE,
					  "Error in MPI_TYPE_EXTENT" );

  /* Assign the extent and return */
  (*extent) = datatype->extent;
  return (MPI_SUCCESS);
}
