/*
 *  $Id: type_size.c,v 1.1 1994/04/18 15:47:07 doss Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include "mpi.h"
#include "mpisys.h"


/*@
    MPI_Type_size - Return the number of bytes occupied by entries
                    in the datatype
@*/
int MPI_Type_size ( datatype, size )
MPI_Datatype  datatype;
MPI_Aint     *size;
{
  /* Check for bad datatype */
  if (datatype == MPI_DATATYPE_NULL) 
	return MPIR_ERROR( MPI_COMM_NULL, MPI_ERR_TYPE,
					  "Error in MPI_TYPE_SIZE" );

  /* Assign the size and return */
  (*size) = datatype->size;
  return (MPI_SUCCESS);
}
