/*
 *  $Id: topo_status.c,v 1.5 1994/03/29 22:26:04 gropp Exp $
 *
 *  (C) 1993 by Argonne National Laboratory and Mississipi State University.
 *      All rights reserved.  See COPYRIGHT in top-level directory.
 */

#include <mpi.h>

/*@

MPI_Topo_status - Determine the type of topology (if any) associated with a 
                  communicator

Input Parameter:
. comm - communicator (handle) 

Output Parameter:
. status - topology type of communicator  comm (choice) 

@*/
int MPI_Topo_status ( comm, status )
MPI_Comm  comm;
int      *status; 
{
  /* Check for valid arguments */
  if ( comm == (MPI_Comm)0 )
    return MPIR_ERROR( (MPI_Comm)0, MPI_ERR_COMM_NULL, 
		      "Error in MPI_TOPO_STATUS" );

  /* Set the status */
  if ( status != (int *)0 )
    (*status) = comm->topology.type;

  return (MPI_SUCCESS);
}
